#########################################
## THIS FILE IS PART OF BRAINGENIX     ##
## COMPUTER NEURON SIMULATUION LIBRARY ##
#########################################

import cv2

class videocapture(): # this class gets the frames from the specified camera

    def __init__(self, captureid, res): # initalizes the capture


        ## CREATE THE CAPTURE ##

        self.fourcc = cv2.VideoWriter_fourcc('M','J','P','G') # tells it to expect mjpg data from the camera
        
        self.capture = cv2.VideoCapture() # initalizes capture
        
        self.capture.open(captureid + cv2.CAP_DSHOW) # creates the capture
        
        self.capture.set(cv2.CAP_PROP_FOURCC, self.fourcc) # sets to decode video from camera
        
        self.capture.set(cv2.CAP_PROP_FRAME_WIDTH, res[0]) # set width in pixels
        
        self.capture.set(cv2.CAP_PROP_FRAME_HEIGHT, res[1]) # set height in pixels
        
        self.capture.set(cv2.CAP_PROP_FPS, 60) # tell it to use 60 fps


        self.devid = captureid # store the device id locally

        print('[INFO] VideoCaputure on DeviceID {} has been established.'.format(str(captureid))) # prints info message


    def read(self): # reads back a frame from the capture


        _, frame = self.capture.read() # read the image from the capture

        return frame # return the frame


    def close(self): # closes the capture


        self.capture.release() # releases the capture

        print('[WARN] VideoCapture on DeviceID {} has been released.'.format(str(self.devid))) # prints warning message
