#########################################
## THIS FILE IS PART OF BRAINGENIX     ##
## COMPUTER NEURON SIMULATUION LIBRARY ##
#########################################

import matplotlib.pyplot as plt


def sum_l(l): # calculates the sum


    tot = 0 # set the total

    for x in l: # iterate through the list

        tot += float(x) # incriment it up


    return tot # return the total value


def Plot_Graph(input_file, output_file, show=False): # plots a graph
    
    ## FIRST, LOAD THE DATA ##

    with open(input_file, 'r') as f: # open the file to read

        d = f.read().split(',') # split the file and read it's contents


    d = d[:-1] # remove the last item which is malformed



    samples_avg = 25 # set the samples in the average

    max_samples = 100 # set the max samples param

    min_samples = 100 # set the min samples param


    ## FORMAT THE ARRAY ##

    data = [] # make an empty list

    avg = [] # make a list for the avg

    avg_pref = [] # make an average last samples



    for x in range(samples_avg): # iterate through the samples to average

        avg_pref.append(d[0]) # set the baseline avg



    for z in d: # iterate through the target array

        data.append(float(z)) # append the data

        
        avg_pref.append(z) # append the point

        del avg_pref[0] # remove the old point


        avg_value = sum_l(avg_pref) / len(avg_pref) # calculate the average


        avg.append(avg_value) # append the average value

        

    ## CALCULATE THE MAX CURVE ##

    max_data = [] # make an array for it





    for z in range(0,len(data),max_samples): # iterate through the data array


        max_samples_l = data[z : z + max_samples] # get the max samples window


        highest_value = max_samples_l[0] # set a starting number

        for x in max_samples_l: # iterate through the highest values


            if x > highest_value: # if it's higher

                highest_value = x # update the highest
        

            max_data.append(highest_value) # append it
            

    avg_max = [] # make a list for the avg

    avg_pref = [] # make an average last samples



    for x in range(samples_avg): # iterate through the samples to average

        avg_pref.append(d[0]) # set the baseline avg



    for z in max_data: # iterate through the target array



        
        avg_pref.append(z) # append the point

        del avg_pref[0] # remove the old point


        avg_value = sum_l(avg_pref) / len(avg_pref) # calculate the average


        avg_max.append(avg_value) # append the average value




    ## CALCULATE THE MIN CURVE ##


    min_data = [] # make a minimum data array




    for z in range(0,len(data),min_samples): # iterate through the data array


        min_samples_l = data[z : z + min_samples] # get the max samples window


        lowest_value = min_samples_l[0] # set a starting number

        for x in min_samples_l: # iterate through the highest values


            if x < lowest_value: # if it's higher

                highest_value = x # update the highest
        

            min_data.append(highest_value) # append it
            

    avg_min = [] # make a list for the avg

    avg_pref = [] # make an average last samples



    for x in range(samples_avg): # iterate through the samples to average

        avg_pref.append(d[0]) # set the baseline avg



    for z in min_data: # iterate through the target array



        
        avg_pref.append(z) # append the point

        del avg_pref[0] # remove the old point


        avg_value = sum_l(avg_pref) / len(avg_pref) # calculate the average


        avg_min.append(avg_value) # append the average value
        

        

    ## PLOT IT ##

    plt.figure(num=None, figsize=(66, 8.5), facecolor='w', edgecolor='k') # resize the graph

    plt.margins(0,0,tight=True) # set the margin


    plt.cla() # clear the axes of the plot



    plt.suptitle('CUMULATIVE NEURON VOLTAGE PLOT (SNN VARIANT 8)') # set graph title


    plt.xlabel('TIME (updates)') # label the x axis

    plt.ylabel('VOLTAGE (mv)') # label the y axis


    #plt.xticks(x_ticks) # set the x ticks


    plt.plot(data) # make the Neuron Activity

    plt.plot(avg) # plot the Average Neuron Activity

    plt.plot(avg_max) # plot the High Neuron Activity

    plt.plot(avg_min) # plot the Min Neuron Activity


    plt.savefig(output_file) # save the graph


    if show: # if we're to show it

        plt.show() # show the graph








