# BrainGenix

This is a framework that simulates real neurons as closely as possible, so that it is possible to make your own Neural Nets that somewhat match real brains. It is multiprocessed, so that it will use as many cpus as you want, and multi machine support is coming soon.


# Graphs

This is a simulation graph of 27 neurons in a 3x3x3 cube. The graph is the neuron voltages summed up, so that you can visulize the Neural Oscillations. 
![27 Neuron Simulation](https://github.com/datacrystals/BrainGenix/Neurons/readme_graphs/g2.png)

Here is a simulation of around 12K neurons, which shows a smaller time scale.
![27 Neuron Simulation](https://github.com/datacrystals/BrainGenix/Neurons/readme_graphs/g4.png)

This is a simulation of 12K neurons, but over a much longer time. Please excuse the other colour lines, they were for averages, max, min, etc.
![27 Neuron Simulation](https://github.com/datacrystals/BrainGenix/Neurons/readme_graphs/g3.png)

Here's the simulation with around 12M neurons, over about 2 seconds. Sadly, i could not run it for longer, due to it just taking too long on my machine. My setup is (2x Xeon E5-2680V2), so it has 20C/40T. 12M neurons is around the limit for 40 Threads. However, it is possible to make this work better with more cpu cores, so that it can be more distributed.
![27 Neuron Simulation](https://github.com/datacrystals/BrainGenix/Neurons/readme_graphs/g5.png)

Lastly, here's the simulation with 27 Neurons over about 100 seconds.
![27 Neuron Simulation](https://github.com/datacrystals/BrainGenix/Neurons/readme_graphs/g6.png)


# Contact

Feel free to email me at ![thomasl20@icloud.com](mailto:thomasl20@icloud.com). I would love to hear about any ideas anyone has to make this work better. More specifically, i would love to know how many other types of neurons are in the brain, and how they behave, so that i can implement them in the simulator. Eventually, i need to know how a baby learns so that i can emulate it with the ai, however that might be a long way off.
